{ this is the propertyeditor for the buttons of TTitleBar. i hope
	it works as it is expected to (on my computers it does what it
  should do). please see CAPBAR.PAS for more details on the
  complete component }

unit CapBarEd;

interface

uses
  WinTypes,WinProcs,SysUtils,Messages,Classes,Graphics,Controls,
  Forms,Dialogs,StdCtrls,ExtCtrls,DsgnIntF,DsgnWnds,LibIntF,
  Buttons,Grids,CapBar,TabNotBk;

type
	{ this is the form that is shown to the user when he clicks the
  	button for the button-property in the objectinspector }
  TTitleBarButtonEdit = class(TDesignWindow)
    Panel4: TPanel;
    But_Exit: TSpeedButton;
    FontDialog: TFontDialog;
    NoteBook: TNotebook;
    Label1: TLabel;
    Label2: TLabel;
    Lbl_Steps: TLabel;
    Lbl_Waves: TLabel;
    Pnl_Left: TPanel;
    Pnl_Right: TPanel;
    Panel12: TPanel;
    PBox_Gradient: TPaintBox;
    SB_Steps: TScrollBar;
    SB_Waves: TScrollBar;
    Panel1: TPanel;
    Panel5: TPanel;
    But_DelLeft: TSpeedButton;
    Panel6: TPanel;
    but_addleft: TSpeedButton;
    Panel7: TPanel;
    But_AddRight: TSpeedButton;
    Panel8: TPanel;
    But_DelRight: TSpeedButton;
    Panel9: TPanel;
    But_Up: TSpeedButton;
    Panel10: TPanel;
    But_Down: TSpeedButton;
    Panel11: TPanel;
    But_Change: TSpeedButton;
    Panel2: TPanel;
    grid_left: TStringGrid;
    Panel3: TPanel;
    grid_right: TStringGrid;
    Panel13: TPanel;
    But_ChangePage: TSpeedButton;
    CB_Active: TCheckBox;
    CB_Swap: TCheckBox;
    CB_ShowCaption: TCheckBox;
    CB_ShowButtons: TCheckBox;
    CB_FullGradient: TCheckBox;
    Panel14: TPanel;
    But_ColorSwap: TSpeedButton;
    RG_Alignment: TRadioGroup;
    CB_ShowIcon: TCheckBox;
    ColorSelect: TColorDialog;
    function GetOwner: TComponent;
    function GetNewName: string;
		function GetFreeIndex: integer;
		function FindButton(Idx: integer;Align: TButAlign): TTitleButton;
    procedure SetButtonFocus(But: TTitleButton);
    procedure But_ExitClick(Sender: TObject);
    procedure But_AddClick(Sender: TObject);
    procedure But_DelClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Grid_DrawCell(Sender: TObject; Col, Row: Longint;
      Rect: TRect; State: TGridDrawState);
    procedure GridSelectCell(Sender: TObject; Col, Row: Longint;
      var CanSelect: Boolean);
    procedure FormShow(Sender: TObject);
    procedure But_ChangeClick(Sender: TObject);
    procedure But_UpDownClick(Sender: TObject);
    procedure PBox_GradientPaint(Sender: TObject);
    procedure PnlColorClick(Sender: TObject);
    procedure PBox_GradientClick(Sender: TObject);
    procedure SB_WavesChange(Sender: TObject);
    procedure SB_StepsChange(Sender: TObject);
    procedure But_ChangePageClick(Sender: TObject);
    procedure GetButtons(Sender: TObject);
		procedure GetValues(Sender: TObject);
    procedure SetValues(Sender: TObject);
    procedure But_ColorSwapClick(Sender: TObject);
  private
  	FButName: TList;					{ the list of buttons }
    FCaller: TTitleBar;       { the calling component }
		procedure ReArrangeIndex;
	public
  	property Buttons: TList read FButName write FButName;
    property Owner: TComponent read GetOwner;
  end;

	{ this is the component that handles the display of our
  	propertyeditor }
  TTitleBarButtons=class(TPropertyEditor)
    function GetAttriButes: TPropertyAttributes; override;
    function GetValue: string; override;
    procedure Edit; override;
  end;

var
  TitleBarButtonEdit: TTitleBarButtonEdit;

implementation

{$R *.DFM}

{ this procedure searches for an existing propertyeditor. this is
	important when the dialog we show is not modal. and it cannot
  be modal since we want to let the user use the objectinspector
  to change the settings of the buttons }
function Createedit: TTitleBarButtonEdit;
var
  i: integer;
begin
	Result:=nil;
  { cycle through all forms on the screen and find the right one }
  for i:=0 to Screen.FormCount-1 do
  begin
    if Screen.Forms[i] is TTitleBarButtonEdit then
    begin
      Result:=TTitleBarButtonEdit(Screen.Forms[i]);
      Break;
    end;
  end;
  if Result=nil then
  begin
  	{ if nothing is found then create it }
  	Result:=TTitleBarButtonEdit.Create(Application);
  end;
end;

{*****************************************************************
***                                                            ***
***  procedures for the propertyeditor                         ***
***                                                            ***
*****************************************************************}
{ this defines the display of the property in the objectinspector:
  paDialog show the three points that open a dialog,
  paValueList shows an arrow to choose the value from a list }
function TTitleBarButtons.GetAttributes:TPropertyAttributes;
begin
  Result:=[paDialog,paReadOnly];
end;

{ this returns the string that is shown in the objectinspector for
	the property. if this isn't overriden then the original value
  will be displayed in the objectinspector (TList, TButton or
  whatever is defined in the calling componen) }
function TTitleBarButtons.GetValue: string;
begin
	Result:='(TitleButtons)';
end;

{ this procedure is called when the user activates the property in
	the objectinspector (i.e. clicking on the three points).
  DON'T FORGET TO DESTROY THE DIALOG WHEN DONE!!!!}
procedure TTitleBarButtons.Edit;
var
	Editor: TTitleBarButtonEdit;
begin
	{ first we have to create the dialog or call an existing one }
	Editor:=CreateEdit;
  { this is the calling component (TitleBar) }
  Editor.FCaller:=TTitleBar(GetComponent(0));
  { the designer is the form with the dialog to set the property
  	(this means it is the form this file here belongs to)}
  Editor.Designer:=TFormDesigner(Designer);
  { now we create the buttonlist and get the values }
  Editor.GetButtons(Self);
  Editor.GetValues(Self);
  { activate the first page of the editor }
  Editor.NoteBook.PageIndex:=0;
  { here we open the dialog. if it is a dialog that completeley
  	handles the properties of the objects then you can do a
    Editor.ShowModal;
    but don't forget to set the visibility of the form to false
    before you do so.}
  Editor.Show;
end;
{*****************************************************************
***                                                            ***
***  procedures for the dialog                                 ***
***                                                            ***
*****************************************************************}
{ this is executed when the form is shown for the first time. }
procedure TTitleBarButtonEdit.FormShow(Sender: TObject);
begin
  Grid_Left.DefaultColWidth:=Grid_Left.Width-2;
  Grid_Right.DefaultColWidth:=Grid_Right.Width-2;
  GetButtons(Self);
end;

{ we have to create a TList-object to hold the list of buttons }
procedure TTitleBarButtonEdit.FormCreate(Sender: TObject);
begin
  FButName:=TList.Create;
end;

{ and also we have to destroy it when done }
procedure TTitleBarButtonEdit.FormDestroy(Sender: TObject);
begin
	FButName.Free;
end;

{ you have to define the FormClose-event in this way. if you don't
	do it then you will get a GPF in the DCL if you leave Delphi }
procedure TTitleBarButtonEdit.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
	Action:=caFree;
end;

{ this returns the ownerform of the component. the place where we
	write our buttons to. }
function TTitleBarButtonEdit.GetOwner: TComponent;
begin
	Result:=Designer.Form;
end;

{ change the page of the editor }
procedure TTitleBarButtonEdit.But_ChangePageClick(Sender: TObject);
begin
  case NoteBook.PageIndex of
  	0:
    begin
    	NoteBook.PageIndex:=1;
      But_ChangePage.Caption:='Buttons';
    end;
    1:
    begin;
	  	NoteBook.PageIndex:=0;
      But_ChangePage.Caption:='Properties';
    end;
  end;
end;

{ recalculate indices of buttons. sometimes it can happen that the
	indices of the buttons get mixed. so after getting the buttons
  and showing them in the grids all indices are calculated from
  the grids. }
procedure TTitleBarButtonEdit.ReArrangeIndex;
var
	i: integer;
  But: TTitleButton;
  Idx: integer;
begin
	Idx:=0;
  { set the indices for the buttons in the left grid ascending from
  	top to bottom }
	for i:=0 to Grid_Left.RowCount do
  begin
		But:=FindButton(i,baLeft);
    if But<>nil then
    begin
    	But.FIdx:=Idx;
      inc(Idx);
    end;
  end;
  Idx:=Buttons.Count-1;
  { set the indices in the right grid descending from the top to
  	the bottom }
	for i:=0 to Grid_Right.RowCount do
  begin
		But:=FindButton(i,baRight);
    if But<>nil then
    begin
    	But.FIdx:=Idx;
      dec(Idx);
    end;
  end;
end;

{ find all buttons and create a list of them }
procedure TTitleBarButtonEdit.GetButtons(Sender: TObject);
var
	i,j,k: integer;
  But: TTitleButton;
  LCount,RCount: integer;
begin
  Buttons.Clear;
  LCount:=0;
  RCount:=0;
	for i:=0 to Owner.ComponentCount-1 do
  begin
		if (Owner.Components[i].ClassType=TTitleButton) then
  	begin
      k:=Buttons.Count;
	 		But:=TTitleButton(Owner.Components[i]);
    	Buttons.Add(But);
      case But.Alignment of
      	baLeft:  	inc(LCount);
        baRight:	inc(RCount);
      end;
      { sort using index }
	    for j:=0 to k do
 		  	if But.FIdx<TTitleButton(Buttons[j]).FIdx then
     			Buttons.Exchange(k,j);
	  end;
  end;

	{ now that the buttons are set to the corresponding grid we
  	can recalculate the indices }
  ReArrangeIndex;
  Grid_Left.RowCount:=LCount;
  Grid_Right.RowCount:=RCount;
	{ only show grids when there are buttons in it }
  Grid_Left.Visible:=LCount<>0;
 	Grid_Right.Visible:=RCount<>0;
	{ repaint the grids }
	Grid_Left.Refresh;
  Grid_Right.Refresh;
end;

{ close button pressed }
procedure TTitleBarButtonEdit.But_ExitClick(Sender: TObject);
begin
	Close;
end;

{ look for the lowest free indexvalue in buttonlist }
function TTitleBarButtonEdit.GetFreeIndex: integer;
var
	i,j: integer;
  Found: boolean;
begin
	{ if there is not index found then the lowest free index is
  	the number of the buttons }
	Result:=Buttons.Count;
  Found:=False;
	for i:=0 to Buttons.Count-1 do
  begin
  	for j:=0 to Buttons.Count-1 do
    begin
	  	if TTitleButton(Buttons[j]).FIdx=i then Found:=True;
    end;
    if not Found then
    begin
    	Result:=i;
      Break;
    end;
  end;
end;

{ get new name for component }
function TTitleBarButtonEdit.GetNewName: string;
var
	i: integer;
begin
	i:=0;
  repeat
  	inc(i);
    { the buttons are named CapBut01 and so on by default. you can
    	change this without any problem. the buttons are not identified
      with their names by titlebar }
		Result:=Format('CapBut%.2d',[i]);
	until Owner.FindComponent(Result)=nil;
end;

{ add button }
procedure TTitleBarButtonEdit.But_AddClick(Sender: TObject);
var
	But: TTitleButton;
begin
	{ i only set this limit here because it makes little sense to
  	define more than 10 buttons in the titlebar. but if you want
    you can set this value higher or remove it completeley }
	if Buttons.Count=10 then
  begin
  	Showmessage('Only 10 Buttons allowed!');
    Exit;
  end;

  But:=TTitleButton.Create(Owner);
  But.Name:=GetNewName;
  But.Caption:=But.Name;
	But.FIdx:=GetFreeIndex;
  if Sender=But_AddLeft then
  	But.Alignment:=baLeft
  else
  	But.Alignment:=baRight;

  GetButtons(Self);
end;

{ delete button }
procedure TTitleBarButtonEdit.But_DelClick(Sender: TObject);
var
	But: TTitleButton;
  FComponents: TComponentList;
begin
	{ only delete a button when the grid that belongs to the button
  	is focused }
  if Sender=But_DelLeft then
  begin
 		if Grid_Left.Focused then
  		But:=FindButton(Grid_Left.Selection.Top,baLeft)
    else
 	  	Exit;
  end
  else if Sender=But_DelRight then
  begin
 		if Grid_Right.Focused then
  		But:=FindButton(Grid_Right.Selection.Top,baRight)
    else
 	  	Exit;
  end
  else
  	Exit;

	{ now we can remove the button }
	But.Free;
  { the objectinspector should show the calling component }
  FComponents:=TComponentList.Create;
  FComponents.Add(FCaller);
	SetSelection(FComponents);
  Designer.Modified;

  GetButtons(Self);
end;

{ sets the focus to the given button }
procedure TTitleBarButtonEdit.SetButtonFocus(But: TTitleButton);
var
	i: integer;
  Idx: integer;
  Grid: TStringGrid;
begin
  if Buttons.Count=0 then Exit;
	Idx:=0;
  i:=0;
  while (i<Buttons.Count) and (Buttons[i]<>But) do
  begin
  	if TTitleButton(Buttons[i]).Alignment=But.Alignment then
    	inc(Idx);
    inc(i);
	end;
	{ button found - set focus }
  if Buttons[i]=But then
  begin
  	if But.Alignment=baLeft then
     	Grid:=Grid_Left
    else
    begin
    	Grid:=Grid_Right;
      Idx:=Grid.RowCount-Idx-1;
    end;

    Grid.SetFocus;
    Grid.Row:=Idx;
  end;
end;

{ returns button number IDX with alignment ALIGN,
	returns NIL if nothing found }
function TTitleBarButtonEdit.FindButton(Idx: integer;Align: TButAlign): TTitleButton;
var
	i,j: integer;
begin
	Result:=nil;
	for i:=0 to Buttons.Count-1 do
  begin
  	if Align=baLeft then j:=i
    else j:=Buttons.Count-1-i;
  	if TTitleButton(Buttons[j]).Alignment=Align then
    begin
    	dec(Idx);
      if Idx<0 then
      begin
      	Result:=TTitleButton(Buttons[j]);
        Break;
      end;
    end;
  end;
end;

{ draw a cell in a grid }
procedure TTitleBarButtonEdit.Grid_DrawCell(Sender: TObject; Col,
  Row: Longint; Rect: TRect; State: TGridDrawState);
var
	Cvs: TCanvas;
  But: TTitleButton;
  IsSelected: boolean;
  S: TCapStr;
begin
	{ find the button that is placed in the cell }
  if Sender=Grid_Left then
  	But:=FindButton(Row,baLeft)
  else
  	But:=FindButton(Row,baRight);
	{ if no button is placed in the cell then we can leave here }
  if But=nil then Exit;

	Cvs:=TStringGrid(Sender).Canvas;
  IsSelected:=gdFocused in State;

  if IsSelected then
  	Cvs.Brush.Color:=clHighLight
  else
  	Cvs.Brush.Color:=TStringGrid(Sender).Color;
  Cvs.Fillrect(Rect);

  S:=But.Caption;
  case But.Alignment of
  	baLeft:		Rect.Right:=Rect.Left+But.Width;
  	baRight:	Rect.Left:=Rect.Right-But.Width;
  end;

  { now we let the calling component do the drawing of the button.
  	this guarantees that the button looks like it will look in
    the captionbar }
	But.Down:=IsSelected;
  But.Rec:=Rect;
  FCaller.ShowButton(Cvs,But);
end;

{ show the selected button in the objectinspector }
procedure TTitleBarButtonEdit.GridSelectCell(Sender: TObject; Col,
  Row: Longint; var CanSelect: Boolean);
var
	FComponents: TComponentList;
  But: TTitleButton;
begin
	if Sender=Grid_Left then
		But:=FindButton(Row,baLeft)
  else
  	But:=FindButton(Row,baRight);
  if But=nil then Exit;

  FComponents:=TComponentList.Create;
  FComponents.Add(But);
	SetSelection(FComponents);
  Designer.Modified;
end;

{ swap from Left to Right and vice versa }
procedure TTitleBarButtonEdit.But_ChangeClick(Sender: TObject);
var
	But: TTitleButton;
begin
  Grid_Left.Visible:=True;
  Grid_Right.Visible:=True;

	if Grid_Left.Focused then
		But:=FindButton(Grid_Left.Selection.Top,baLeft)
  else
  	But:=FindButton(Grid_Right.Selection.Top,baRight);

	if But<>nil then
  begin
  	case But.Alignment of
    	baLeft:
      begin
      	But.Alignment:=baRight;
        Grid_Right.SetFocus;
      end;
      baRight:
      begin
      	But.Alignment:=baLeft;
        Grid_Left.SetFocus;
      end;
    end;
  end;
	GetButtons(Self);
  SetButtonFocus(But);
end;

{ set button one poition up or down, depending on the calling
	object }
procedure TTitleBarButtonEdit.But_UpDownClick(Sender: TObject);
var
	But1,But2: TTitleButton;
  i: integer;
  IsUp: boolean;
begin
	if Grid_Left.Focused then
  begin
		But1:=FindButton(Grid_Left.Selection.Top,baLeft);
		if But1=nil then Exit;
    if Sender=But_Up then
    begin
		  dec(But1.FIdx);
    	IsUp:=True;
    end
    else
    begin
		  inc(But1.FIdx);
    	IsUp:=False;
    end;
  end
  else
  begin
  	But1:=FindButton(Grid_Right.Selection.Top,baRight);
		if But1=nil then Exit;
    if Sender=But_Down then
    begin
		  dec(But1.FIdx);
    	IsUp:=True;
    end
    else
    begin
		  inc(But1.FIdx);
    	IsUp:=False;
    end;
  end;

  { now we have to recalculate the indices to avoid the rearrangement
  	of the buttons by ReArrangeIndex }
	for i:=0 to Buttons.Count-1 do
  begin
		But2:=TTitleButton(Buttons[i]);
    if But2<>But1 then
    begin
	    if IsUp then
      begin
				if (But1.Alignment=baLeft) then
        begin
        	if (But2.FIdx<=But1.FIdx) then inc(But2.FIdx);
        end
				else
        begin
        	if (But2.FIdx>=But1.FIdx) then inc(But2.FIdx);
        end;
      end
      else
      begin
				if (But1.Alignment=baLeft) then
        begin
        	if (But2.FIdx>=But1.FIdx) then dec(But2.FIdx);
        end
				else
        begin
        	if (But2.FIdx<=But1.FIdx) then dec(But2.FIdx);
        end;
      end;
    end;
  end;
  GetButtons(Self);
  SetButtonFocus(But1);
end;

{*****************************************************************
***                                                            ***
***  procedures for the propertieseditor                       ***
***                                                            ***
*****************************************************************}
{ get the values from the titlebarcomponent and set the
	corresponding dialogelements to this values }
procedure TTitleBarButtonEdit.GetValues(Sender: TObject);
begin
	if CB_Active.Checked then
  begin
	  Pnl_Left.Color:=FCaller.ColorActiveLeft;
 		Pnl_Right.Color:=FCaller.ColorActiveRight;
  end
  else
  begin
	  Pnl_Left.Color:=FCaller.ColorInActiveLeft;
 		Pnl_Right.Color:=FCaller.ColorInActiveRight;
  end;
  SB_Steps.Position:=FCaller.GradientSteps;
  SB_Waves.Position:=FCaller.GradientWaves;
  { i use the Tag of the form to tell the SetValues-procedure not
  	to do anything. because if the state of a checkbox is checked
    the OnClick-event of this checkbox is executed. and this
    results in wrong values if we set the first checkbox because
    the OnClick-event of the checkboxes on this form is connected
    to the SetValues-procedure which sets all values to the
    corresponding checkboxes }
  Self.Tag:=1;
  CB_Swap.Checked:=FCaller.GradientSwap;
  CB_ShowCaption.Checked:=FCaller.ShowCaption;
  CB_ShowButtons.Checked:=FCaller.ShowButtons;
  CB_ShowIcon.Checked:=FCaller.ShowIcon;
  CB_FullGradient.Checked:=FCaller.FullGradient;
  RG_Alignment.ItemIndex:=Ord(FCaller.CaptionAlignment);
  Self.Tag:=0;
  { now we have to update the display of the gradient}
  PBox_GradientPaint(Self);
end;

{ get the values from the form and set it to the titlebarcomponent }
procedure TTitleBarButtonEdit.SetValues(Sender: TObject);
begin
	{ don't get the values if the Tag of the form is not 0 }
	if Self.Tag=0 then
  begin
		if CB_Active.Checked then
	  begin
	  	FCaller.ColorActiveLeft:=Pnl_Left.Color;
 			FCaller.ColorActiveRight:=Pnl_Right.Color;
	  end
  	else
	  begin
		  FCaller.ColorInActiveLeft:=Pnl_Left.Color;
 			FCaller.ColorInActiveRight:=Pnl_Right.Color;
	  end;
	  FCaller.GradientSwap:=CB_Swap.Checked;
  	FCaller.ShowCaption:=CB_ShowCaption.Checked;
	  FCaller.ShowButtons:=CB_ShowButtons.Checked;
  	FCaller.ShowIcon:=CB_ShowIcon.Checked;
  	FCaller.FullGradient:=CB_FullGradient.Checked;
    FCaller.CaptionAlignment:=TCapAlign(RG_Alignment.ItemIndex);
  	{ tell the designer that something has changed }
	  Designer.Modified;
  	{ now we have to update the display of the gradient}
	  PBox_GradientPaint(Self);
  end;
end;

{ draw the gradient in the paintbox }
procedure TTitleBarButtonEdit.PBox_GradientPaint(Sender: TObject);
var
	Limit: TLimit;
  R: TRect;
  FBmp: TBitmap;
  Cvs: TCanvas;
begin
	FBmp:=TBitmap.Create;
  try
		R:=Rect(0,0,PBox_Gradient.Width,PBox_Gradient.Height);
    { define the dimensions of the bitmap }
    FBmp.Width:=R.Right;
    FBmp.Height:=R.Bottom;
    { now we have a canvas we can paint on }
    Cvs:=FBmp.Canvas;
		Limit.Left:=R.Left;
	  Limit.Right:=R.Right;
  	{ to show the buttons we have to assign our buttonlist to the
  		buttonlist of the titlebarcomponent }
	  FCaller.Buttons:=Buttons;
    InflateRect(R,1,1);
    if FCaller.ShowIcon then
    begin
    	R:=FCaller.DrawIcon(Cvs,R);
      inc(R.Left);
    end;
  	{ now almost the same section follows as in CAPBAR.PAS }
	  if FCaller.FGradAll then
  	begin
	   	Limit.Left:=R.Left+1;
  	  Limit.Right:=R.Right;
			FCaller.DrawGradient(CB_Active.Checked,Cvs,R,Limit);
	  end;
  	  Limit:=FCaller.ShowTitleButtons(Cvs,R);
	  if not FCaller.FullGradient then
			FCaller.DrawGradient(CB_Active.Checked,Cvs,R,Limit);
    { copy the painted caption to the paintbox }
    PBox_Gradient.Canvas.Draw(0,0,FBmp);
  finally
	  { and now it is important to release the buttons. if we didn't do
  		this, there would be a GPF when we try to close the form with
	    our component on it }
  	FCaller.Buttons:=nil;
    FBmp.Free;
  end;
end;

{ change the font if the paintbox is clicked }
procedure TTitleBarButtonEdit.PBox_GradientClick(Sender: TObject);
begin
	FontDialog.Font.Assign(FCaller.Font);
  { change the color of the font if the inactive colors are shown }
  if not CB_Active.Checked then
  	FontDialog.Font.Color:=FCaller.CaptionInActive;
	if FontDialog.Execute then
  begin
  	if not CB_Active.Checked then
    begin
      FCaller.CaptionInActive:=FontDialog.Font.Color;
      FontDialog.Font.Color:=FCaller.Font.Color;
    	FCaller.Font:=FontDialog.Font;
    end
    else
	  	FCaller.Font:=FontDialog.Font;
    Designer.Modified;
	  PBox_GradientPaint(Self);
  end;
end;

{ define left color of gradient }
procedure TTitleBarButtonEdit.PnlColorClick(Sender: TObject);
begin
	GetValues(Self);
	ColorSelect.Color:=TPanel(Sender).Color;
  { show colordialog and change colors if color has been chosen }
	if ColorSelect.Execute then
  begin
  	if Sender=Pnl_Left then
    	if CB_Active.Checked then
    		FCaller.ColorActiveLeft:=ColorSelect.Color
      else
    		FCaller.ColorInActiveLeft:=ColorSelect.Color
    else
    	if CB_Active.Checked then
	    	FCaller.ColorActiveRight:=ColorSelect.Color
      else
	    	FCaller.ColorInActiveRight:=ColorSelect.Color;
    TPanel(Sender).Color:=ColorSelect.Color;
    Designer.Modified;
    PBox_GradientPaint(Self);
  end;
end;

{ the number of waves has changed }
procedure TTitleBarButtonEdit.SB_WavesChange(Sender: TObject);
begin
	FCaller.GradientWaves:=SB_Waves.Position;
  Lbl_Waves.Caption:=IntToStr(SB_Waves.Position);
  Designer.Modified;
	PBox_GradientPaint(Self);
end;

{ the number of steps has changed }
procedure TTitleBarButtonEdit.SB_StepsChange(Sender: TObject);
begin
	FCaller.GradientSteps:=SB_Steps.Position;
  { recalculate the maximum number of waves allowed }
  SB_Waves.Max:=SB_Steps.Position div 4;
  Lbl_Steps.Caption:=IntToStr(SB_Steps.Position);
  Designer.Modified;
	PBox_GradientPaint(Self);
end;

{ swap the colors from left to right }
procedure TTitleBarButtonEdit.But_ColorSwapClick(Sender: TObject);
var
	Color: TColor;
begin
	Color:=Pnl_Left.Color;
  Pnl_Left.Color:=Pnl_Right.Color;
  Pnl_Right.Color:=Color;
  SetValues(Self);
  Designer.Modified;
  PBox_GradientPaint(Self);
end;

end.
